/* window_mapper.c generated by valac 0.56.17, the Vala compiler
 * generated from window_mapper.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "windowing.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <libxfce4windowing/libxfce4windowing.h>
#include <libwnck/libwnck.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	BUDGIE_WINDOWING_WINDOW_MAPPER_0_PROPERTY,
	BUDGIE_WINDOWING_WINDOW_MAPPER_NUM_PROPERTIES
};
static GParamSpec* budgie_windowing_window_mapper_properties[BUDGIE_WINDOWING_WINDOW_MAPPER_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _BudgieWindowingWindowMapperPrivate {
	GHashTable* applications;
	GHashTable* startup_infos;
	GHashTable* simpletons;
	GHashTable* pids;
	GAppInfoMonitor* monitor;
	GDBusConnection* bus;
	gboolean invalidated;
	GRecMutex __lock_invalidated;
};

static gint BudgieWindowingWindowMapper_private_offset;
static gpointer budgie_windowing_window_mapper_parent_class = NULL;

static void budgie_windowing_window_mapper_on_dbus_get (BudgieWindowingWindowMapper* self,
                                                 GObject* object,
                                                 GAsyncResult* res);
static void budgie_windowing_window_mapper_app_launched (BudgieWindowingWindowMapper* self,
                                                  GDBusConnection* conn,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* signal_name,
                                                  GVariant* parameters);
static void _budgie_windowing_window_mapper_app_launched_gd_bus_signal_callback (GDBusConnection* connection,
                                                                          const gchar* sender_name,
                                                                          const gchar* object_path,
                                                                          const gchar* interface_name,
                                                                          const gchar* signal_name,
                                                                          GVariant* parameters,
                                                                          gpointer self);
static gint64* _int64_dup (gint64* self);
static void budgie_windowing_window_mapper_check_invalidated (BudgieWindowingWindowMapper* self);
static void budgie_windowing_window_mapper_load_app_infos (BudgieWindowingWindowMapper* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gchar* budgie_windowing_window_mapper_get_group_name (BudgieWindowingWindowMapper* self,
                                                      XfwWindow* window);
static gchar* budgie_windowing_window_mapper_query_atom_string (BudgieWindowingWindowMapper* self,
                                                         gulong xid,
                                                         GdkAtom atom,
                                                         gboolean utf8);
static GDesktopAppInfo* budgie_windowing_window_mapper_query_simpletons (BudgieWindowingWindowMapper* self,
                                                                  const gchar* name);
static GDesktopAppInfo* budgie_windowing_window_mapper_query_name (BudgieWindowingWindowMapper* self,
                                                            const gchar* name);
static GObject * budgie_windowing_window_mapper_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void _g_free0_ (gpointer var);
static void _budgie_windowing_window_mapper_on_dbus_get_gasync_ready_callback (GObject* source_object,
                                                                        GAsyncResult* res,
                                                                        gpointer self);
static void _budgie_windowing_window_mapper___lambda4_ (BudgieWindowingWindowMapper* self);
static gboolean __lambda5_ (BudgieWindowingWindowMapper* self);
static gboolean ___lambda5__gsource_func (gpointer self);
static void __budgie_windowing_window_mapper___lambda4__g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                             gpointer self);
static void budgie_windowing_window_mapper_finalize (GObject * obj);
static GType budgie_windowing_window_mapper_get_type_once (void);
static gssize _vala_array_length (gpointer array);

static inline gpointer
budgie_windowing_window_mapper_get_instance_private (BudgieWindowingWindowMapper* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieWindowingWindowMapper_private_offset);
}

static void
_budgie_windowing_window_mapper_app_launched_gd_bus_signal_callback (GDBusConnection* connection,
                                                                     const gchar* sender_name,
                                                                     const gchar* object_path,
                                                                     const gchar* interface_name,
                                                                     const gchar* signal_name,
                                                                     GVariant* parameters,
                                                                     gpointer self)
{
	budgie_windowing_window_mapper_app_launched ((BudgieWindowingWindowMapper*) self, connection, sender_name, object_path, interface_name, signal_name, parameters);
}

static void
budgie_windowing_window_mapper_on_dbus_get (BudgieWindowingWindowMapper* self,
                                            GObject* object,
                                            GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GDBusConnection* _tmp0_ = NULL;
		GDBusConnection* _tmp1_;
		GDBusConnection* _tmp2_;
		GDBusConnection* _tmp3_;
		_tmp1_ = g_bus_get_finish (res, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->bus);
		self->priv->bus = _tmp2_;
		_tmp3_ = self->priv->bus;
		g_dbus_connection_signal_subscribe (_tmp3_, NULL, "org.gtk.gio.DesktopAppInfo", "Launched", "/org/gtk/gio/DesktopAppInfo", NULL, 0, _budgie_windowing_window_mapper_app_launched_gd_bus_signal_callback, g_object_ref (self), g_object_unref);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_critical ("window_mapper.vala:70: Unable to get Session bus: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}

static gpointer
__int64_dup0 (gpointer self)
{
	return self ? _int64_dup (self) : NULL;
}

static void
budgie_windowing_window_mapper_app_launched (BudgieWindowingWindowMapper* self,
                                             GDBusConnection* conn,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* signal_name,
                                             GVariant* parameters)
{
	GVariant* desktop_variant = NULL;
	gint64 pid = 0LL;
	GVariant* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	gchar* desktop_file = NULL;
	GVariant* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	GHashTable* _tmp7_;
	gint64* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (conn != NULL);
	g_return_if_fail (object_path != NULL);
	g_return_if_fail (interface_name != NULL);
	g_return_if_fail (signal_name != NULL);
	g_return_if_fail (parameters != NULL);
	g_variant_get (parameters, "(@aysxas@a{sv})", &_tmp0_, NULL, &_tmp1_, NULL, NULL, NULL);
	_g_variant_unref0 (desktop_variant);
	desktop_variant = _tmp0_;
	pid = _tmp1_;
	_tmp2_ = desktop_variant;
	_tmp3_ = g_variant_get_bytestring (_tmp2_);
	_tmp4_ = g_strdup (_tmp3_);
	desktop_file = _tmp4_;
	_tmp6_ = desktop_file;
	if (g_strcmp0 (_tmp6_, "") == 0) {
		_tmp5_ = TRUE;
	} else {
		_tmp5_ = pid == ((gint64) 0);
	}
	if (_tmp5_) {
		_g_free0 (desktop_file);
		_g_variant_unref0 (desktop_variant);
		return;
	}
	_tmp7_ = self->priv->pids;
	_tmp8_ = __int64_dup0 (&pid);
	_tmp9_ = desktop_file;
	_tmp10_ = g_strdup (_tmp9_);
	g_hash_table_insert (_tmp7_, _tmp8_, _tmp10_);
	_g_free0 (desktop_file);
	_g_variant_unref0 (desktop_variant);
}

/**
* We lazily check if at some point we became invalidated. In most cases
* a package operation or similar modified a desktop file, i.e. making it
* available or unavailable.
*
* Instead of immediately reloading the appsystem we wait until something
* is actually requested again, check if we're invalidated, reload and then
* set us validated again.
*/
static void
budgie_windowing_window_mapper_check_invalidated (BudgieWindowingWindowMapper* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	if (self->priv->invalidated) {
		{
			g_rec_mutex_lock (&self->priv->__lock_invalidated);
			{
				budgie_windowing_window_mapper_load_app_infos (self);
				self->priv->invalidated = FALSE;
			}
			__finally0:
			{
				g_rec_mutex_unlock (&self->priv->__lock_invalidated);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
}

/**
* Reload and cache all the desktop IDs.
*/
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
budgie_windowing_window_mapper_load_app_infos (BudgieWindowingWindowMapper* self)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	GList* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->applications;
	g_hash_table_remove_all (_tmp0_);
	_tmp1_ = self->priv->startup_infos;
	g_hash_table_remove_all (_tmp1_);
	_tmp2_ = g_app_info_get_all ();
	{
		GList* app_info_collection = NULL;
		GList* app_info_it = NULL;
		app_info_collection = _tmp2_;
		for (app_info_it = app_info_collection; app_info_it != NULL; app_info_it = app_info_it->next) {
			GAppInfo* _tmp3_;
			GAppInfo* app_info = NULL;
			_tmp3_ = _g_object_ref0 ((GAppInfo*) app_info_it->data);
			app_info = _tmp3_;
			{
				GDesktopAppInfo* desktop_info = NULL;
				GAppInfo* _tmp4_;
				GDesktopAppInfo* _tmp5_;
				gchar* desktop_id = NULL;
				GDesktopAppInfo* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				GDesktopAppInfo* _tmp9_;
				const gchar* _tmp10_;
				GHashTable* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				GDesktopAppInfo* _tmp20_;
				GDesktopAppInfo* _tmp21_;
				_tmp4_ = app_info;
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, G_TYPE_DESKTOP_APP_INFO) ? ((GDesktopAppInfo*) _tmp4_) : NULL);
				desktop_info = _tmp5_;
				_tmp6_ = desktop_info;
				_tmp7_ = g_app_info_get_id ((GAppInfo*) _tmp6_);
				_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
				desktop_id = _tmp8_;
				_tmp9_ = desktop_info;
				_tmp10_ = g_desktop_app_info_get_startup_wm_class (_tmp9_);
				if (_tmp10_ != NULL) {
					GHashTable* _tmp11_;
					GDesktopAppInfo* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					GDesktopAppInfo* _tmp15_;
					GDesktopAppInfo* _tmp16_;
					_tmp11_ = self->priv->startup_infos;
					_tmp12_ = desktop_info;
					_tmp13_ = g_desktop_app_info_get_startup_wm_class (_tmp12_);
					_tmp14_ = g_utf8_strdown (_tmp13_, (gssize) -1);
					_tmp15_ = desktop_info;
					_tmp16_ = _g_object_ref0 (_tmp15_);
					g_hash_table_insert (_tmp11_, _tmp14_, _tmp16_);
				}
				_tmp17_ = self->priv->applications;
				_tmp18_ = desktop_id;
				_tmp19_ = g_strdup (_tmp18_);
				_tmp20_ = desktop_info;
				_tmp21_ = _g_object_ref0 (_tmp20_);
				g_hash_table_insert (_tmp17_, _tmp19_, _tmp21_);
				_g_free0 (desktop_id);
				_g_object_unref0 (desktop_info);
				_g_object_unref0 (app_info);
			}
		}
		(app_info_collection == NULL) ? NULL : (app_info_collection = (_g_list_free__g_object_unref0_ (app_info_collection), NULL));
	}
}

/**
 * Try to get application group from its WM_CLASS property or fallback to using
 * the app name when WM_CLASS isn't set (e.g. LibreOffice, Google Chrome, Android Studio emulator, maybe others)
 */
static gchar*
budgie_windowing_window_mapper_get_group_name (BudgieWindowingWindowMapper* self,
                                               XfwWindow* window)
{
	WnckWindow* wnck_window = NULL;
	WnckWindow* _tmp6_;
	gchar* name = NULL;
	WnckWindow* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
	gboolean _tmp16_ = FALSE;
	const gchar* _tmp17_;
	const gchar* _tmp21_;
	const gchar* _tmp24_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (window != NULL, NULL);
	if (xfw_windowing_get () == XFW_WINDOWING_WAYLAND) {
		const gchar* _tmp0_ = NULL;
		gchar** _tmp1_;
		gchar** _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp5_;
		_tmp2_ = _tmp1_ = xfw_window_get_class_ids (window);
		_tmp3_ = _tmp2_[0];
		_tmp0_ = _tmp3_;
		if (_tmp0_ == NULL) {
			const gchar* _tmp4_;
			_tmp4_ = xfw_window_get_name (window);
			_tmp0_ = _tmp4_;
		}
		_tmp5_ = g_strdup (_tmp0_);
		result = _tmp5_;
		return result;
	}
	_tmp6_ = wnck_window_get ((gulong) xfw_window_x11_get_xid (window));
	wnck_window = _tmp6_;
	_tmp7_ = wnck_window;
	_tmp8_ = wnck_window_get_class_group_name (_tmp7_);
	_tmp9_ = g_strdup (_tmp8_);
	name = _tmp9_;
	_tmp11_ = name;
	if (_tmp11_ == NULL) {
		_tmp10_ = TRUE;
	} else {
		const gchar* _tmp12_;
		_tmp12_ = name;
		_tmp10_ = g_strcmp0 (_tmp12_, "") == 0;
	}
	if (_tmp10_) {
		WnckWindow* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp13_ = wnck_window;
		_tmp14_ = wnck_window_get_class_instance_name (_tmp13_);
		_tmp15_ = g_strdup (_tmp14_);
		_g_free0 (name);
		name = _tmp15_;
	}
	_tmp17_ = name;
	if (_tmp17_ == NULL) {
		_tmp16_ = TRUE;
	} else {
		const gchar* _tmp18_;
		_tmp18_ = name;
		_tmp16_ = g_strcmp0 (_tmp18_, "") == 0;
	}
	if (_tmp16_) {
		const gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp19_ = xfw_window_get_name (window);
		_tmp20_ = g_strdup (_tmp19_);
		_g_free0 (name);
		name = _tmp20_;
	}
	_tmp21_ = name;
	if (_tmp21_ != NULL) {
		const gchar* _tmp22_;
		gchar* _tmp23_;
		_tmp22_ = name;
		_tmp23_ = g_utf8_strdown (_tmp22_, (gssize) -1);
		_g_free0 (name);
		name = _tmp23_;
	}
	_tmp24_ = name;
	if (g_strcmp0 (_tmp24_, "google chrome") == 0) {
		gchar* _tmp25_;
		_tmp25_ = g_strdup ("google-chrome");
		_g_free0 (name);
		name = _tmp25_;
	}
	result = name;
	return result;
}

static gchar*
budgie_windowing_window_mapper_query_atom_string (BudgieWindowingWindowMapper* self,
                                                  gulong xid,
                                                  GdkAtom atom,
                                                  gboolean utf8)
{
	guint8* data = NULL;
	gint data_length1;
	gint _data_size_;
	GdkAtom type = (GdkAtom) 0U;
	gint format = 0;
	GdkX11Display* display = NULL;
	GdkDisplay* _tmp0_;
	GdkX11Display* _tmp1_;
	GdkAtom req_type = (GdkAtom) 0U;
	GdkWindow* foreign = NULL;
	GdkX11Display* _tmp2_;
	GdkX11Window* _tmp3_;
	GdkWindow* _tmp4_;
	GdkWindow* _tmp5_;
	GdkAtom _tmp6_ = (GdkAtom) 0U;
	gint _tmp7_ = 0;
	guint8* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	const gchar* _tmp10_ = NULL;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp13_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	data = NULL;
	data_length1 = 0;
	_data_size_ = data_length1;
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gdk_x11_display_get_type (), GdkX11Display));
	display = _tmp1_;
	if (utf8) {
		req_type = gdk_atom_intern ("UTF8_STRING", FALSE);
	} else {
		req_type = gdk_atom_intern ("STRING", FALSE);
	}
	_tmp2_ = display;
	_tmp3_ = (GdkX11Window*) gdk_x11_window_foreign_new_for_display (_tmp2_, (Window) xid);
	foreign = (GdkWindow*) _tmp3_;
	_tmp4_ = foreign;
	if (_tmp4_ == NULL) {
		result = NULL;
		_g_object_unref0 (foreign);
		_g_object_unref0 (display);
		data = (g_free (data), NULL);
		return result;
	}
	_tmp5_ = foreign;
	gdk_property_get (_tmp5_, atom, req_type, (gulong) 0, (gulong) G_MAXLONG, 0, &_tmp6_, &_tmp7_, &_tmp9_, &_tmp8_);
	type = _tmp6_;
	format = _tmp7_;
	data = (g_free (data), NULL);
	data = _tmp8_;
	data_length1 = _tmp9_;
	_data_size_ = data_length1;
	_tmp11_ = data;
	_tmp11__length1 = data_length1;
	if (_tmp11_ != NULL) {
		guint8* _tmp12_;
		gint _tmp12__length1;
		_tmp12_ = data;
		_tmp12__length1 = data_length1;
		_tmp10_ = (const gchar*) _tmp12_;
	} else {
		_tmp10_ = NULL;
	}
	_tmp13_ = g_strdup (_tmp10_);
	result = _tmp13_;
	_g_object_unref0 (foreign);
	_g_object_unref0 (display);
	data = (g_free (data), NULL);
	return result;
}

/**
 * Try to get the DesktopAppInfo for a name by looking at our
 * list of simpletons. This function also tries some special
 * cases to try to get the correct match.
 */
static GDesktopAppInfo*
budgie_windowing_window_mapper_query_simpletons (BudgieWindowingWindowMapper* self,
                                                 const gchar* name)
{
	GDesktopAppInfo* info = NULL;
	gchar* desktop_name = NULL;
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	GDesktopAppInfo* _tmp21_;
	GDesktopAppInfo* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	info = NULL;
	desktop_name = NULL;
	_tmp0_ = self->priv->simpletons;
	_tmp1_ = g_utf8_strdown (name, (gssize) -1);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_hash_table_contains (_tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	if (_tmp3_) {
		GHashTable* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gconstpointer _tmp7_;
		gchar* _tmp8_;
		GHashTable* _tmp9_;
		const gchar* _tmp10_;
		_tmp4_ = self->priv->simpletons;
		_tmp5_ = g_utf8_strdown (name, (gssize) -1);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_hash_table_lookup (_tmp4_, _tmp6_);
		_tmp8_ = g_strconcat ((const gchar*) _tmp7_, ".desktop", NULL);
		_g_free0 (desktop_name);
		desktop_name = _tmp8_;
		_g_free0 (_tmp6_);
		_tmp9_ = self->priv->applications;
		_tmp10_ = desktop_name;
		if (g_hash_table_contains (_tmp9_, _tmp10_)) {
			GHashTable* _tmp11_;
			const gchar* _tmp12_;
			gconstpointer _tmp13_;
			GDesktopAppInfo* _tmp14_;
			_tmp11_ = self->priv->applications;
			_tmp12_ = desktop_name;
			_tmp13_ = g_hash_table_lookup (_tmp11_, _tmp12_);
			_tmp14_ = _g_object_ref0 ((GDesktopAppInfo*) _tmp13_);
			_g_object_unref0 (info);
			info = _tmp14_;
		} else {
			GHashTable* _tmp15_;
			const gchar* _tmp16_;
			_tmp15_ = self->priv->startup_infos;
			_tmp16_ = desktop_name;
			if (g_hash_table_contains (_tmp15_, _tmp16_)) {
				GHashTable* _tmp17_;
				const gchar* _tmp18_;
				gconstpointer _tmp19_;
				GDesktopAppInfo* _tmp20_;
				_tmp17_ = self->priv->startup_infos;
				_tmp18_ = desktop_name;
				_tmp19_ = g_hash_table_lookup (_tmp17_, _tmp18_);
				_tmp20_ = _g_object_ref0 ((GDesktopAppInfo*) _tmp19_);
				_g_object_unref0 (info);
				info = _tmp20_;
			}
		}
	}
	_tmp21_ = info;
	if (_tmp21_ == NULL) {
		const gchar* _tmp22_;
		GQuark _tmp24_ = 0U;
		static GQuark _tmp23_label0 = 0;
		static GQuark _tmp23_label1 = 0;
		_tmp22_ = name;
		_tmp24_ = (NULL == _tmp22_) ? 0 : g_quark_from_string (_tmp22_);
		if (_tmp24_ == ((0 != _tmp23_label0) ? _tmp23_label0 : (_tmp23_label0 = g_quark_from_static_string ("google-chrome")))) {
			switch (0) {
				default:
				{
					gchar* _tmp25_;
					const gchar* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					GDesktopAppInfo* _tmp29_;
					_tmp25_ = g_strdup ("com.google.Chrome");
					_g_free0 (desktop_name);
					desktop_name = _tmp25_;
					_tmp26_ = desktop_name;
					_tmp27_ = g_strconcat (_tmp26_, ".desktop", NULL);
					_tmp28_ = _tmp27_;
					_tmp29_ = g_desktop_app_info_new (_tmp28_);
					_g_object_unref0 (info);
					info = _tmp29_;
					_g_free0 (_tmp28_);
					break;
				}
			}
		} else if (_tmp24_ == ((0 != _tmp23_label1) ? _tmp23_label1 : (_tmp23_label1 = g_quark_from_static_string ("google-chrome-unstable")))) {
			switch (0) {
				default:
				{
					gchar* _tmp30_;
					const gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					GDesktopAppInfo* _tmp34_;
					_tmp30_ = g_strdup ("com.google.ChromeDev");
					_g_free0 (desktop_name);
					desktop_name = _tmp30_;
					_tmp31_ = desktop_name;
					_tmp32_ = g_strconcat (_tmp31_, ".desktop", NULL);
					_tmp33_ = _tmp32_;
					_tmp34_ = g_desktop_app_info_new (_tmp33_);
					_g_object_unref0 (info);
					info = _tmp34_;
					_g_free0 (_tmp33_);
					break;
				}
			}
		} else {
			switch (0) {
				default:
				{
					break;
				}
			}
		}
	}
	result = info;
	_g_free0 (desktop_name);
	return result;
}

/**
 * Try to get the DesktopAppInfo for a name. The name used
 * is generally the window's class group name or instance name.
 *
 * The function looks at our started applications and cached
 * applications. If both of those fail, then it looks at
 * the simpleton applications.
 */
static GDesktopAppInfo*
budgie_windowing_window_mapper_query_name (BudgieWindowingWindowMapper* self,
                                           const gchar* name)
{
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	GHashTable* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gboolean _tmp15_;
	GDesktopAppInfo* simpleton = NULL;
	GDesktopAppInfo* _tmp24_;
	GDesktopAppInfo* _tmp25_;
	GDesktopAppInfo* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = self->priv->startup_infos;
	_tmp1_ = g_utf8_strdown (name, (gssize) -1);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_hash_table_contains (_tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	if (_tmp3_) {
		GHashTable* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gconstpointer _tmp7_;
		GDesktopAppInfo* _tmp8_;
		GDesktopAppInfo* _tmp9_;
		_tmp4_ = self->priv->startup_infos;
		_tmp5_ = g_utf8_strdown (name, (gssize) -1);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_hash_table_lookup (_tmp4_, _tmp6_);
		_tmp8_ = _g_object_ref0 ((GDesktopAppInfo*) _tmp7_);
		_tmp9_ = _tmp8_;
		_g_free0 (_tmp6_);
		result = _tmp9_;
		return result;
	}
	_tmp10_ = self->priv->applications;
	_tmp11_ = g_utf8_strdown (name, (gssize) -1);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strconcat (_tmp12_, ".desktop", NULL);
	_tmp14_ = _tmp13_;
	_tmp15_ = g_hash_table_contains (_tmp10_, _tmp14_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
	if (_tmp15_) {
		GHashTable* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gconstpointer _tmp21_;
		GDesktopAppInfo* _tmp22_;
		GDesktopAppInfo* _tmp23_;
		_tmp16_ = self->priv->applications;
		_tmp17_ = g_utf8_strdown (name, (gssize) -1);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_strconcat (_tmp18_, ".desktop", NULL);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_hash_table_lookup (_tmp16_, _tmp20_);
		_tmp22_ = _g_object_ref0 ((GDesktopAppInfo*) _tmp21_);
		_tmp23_ = _tmp22_;
		_g_free0 (_tmp20_);
		_g_free0 (_tmp18_);
		result = _tmp23_;
		return result;
	}
	_tmp24_ = budgie_windowing_window_mapper_query_simpletons (self, name);
	simpleton = _tmp24_;
	_tmp25_ = simpleton;
	if (_tmp25_ != NULL) {
		result = simpleton;
		return result;
	}
	result = NULL;
	_g_object_unref0 (simpleton);
	return result;
}

/**
* Attempt to gain the DesktopAppInfo relating to a given window.
*/
GDesktopAppInfo*
budgie_windowing_window_mapper_query_window (BudgieWindowingWindowMapper* self,
                                             XfwWindow* window)
{
	XfwApplicationInstance* instance = NULL;
	XfwApplication* _tmp0_;
	XfwApplication* _tmp1_;
	XfwApplication* _tmp2_;
	XfwApplicationInstance* _tmp3_;
	XfwApplicationInstance* _tmp4_;
	XfwApplicationInstance* _tmp5_;
	gint pid = 0;
	XfwApplicationInstance* _tmp6_;
	GHashTable* _tmp7_;
	gint64 _tmp8_;
	gchar* gtk_id = NULL;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	WnckWindow* wnck_window = NULL;
	WnckWindow* _tmp28_;
	gchar* class_group_name = NULL;
	WnckWindow* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp34_;
	const gchar* instance_name = NULL;
	WnckWindow* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	GDesktopAppInfo* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (window != NULL, NULL);
	g_object_get (window, "application", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = xfw_application_get_instance (_tmp2_, window);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp2_);
	instance = _tmp4_;
	_tmp5_ = instance;
	if (_tmp5_ == NULL) {
		result = NULL;
		return result;
	}
	_tmp6_ = instance;
	pid = xfw_application_instance_get_pid (_tmp6_);
	_tmp7_ = self->priv->pids;
	_tmp8_ = (gint64) pid;
	if (g_hash_table_contains (_tmp7_, &_tmp8_)) {
		gchar* file_name = NULL;
		GHashTable* _tmp9_;
		gint64 _tmp10_;
		gconstpointer _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		GDesktopAppInfo* _tmp14_;
		_tmp9_ = self->priv->pids;
		_tmp10_ = (gint64) pid;
		_tmp11_ = g_hash_table_lookup (_tmp9_, &_tmp10_);
		_tmp12_ = g_strdup ((const gchar*) _tmp11_);
		file_name = _tmp12_;
		_tmp13_ = file_name;
		_tmp14_ = g_desktop_app_info_new_from_filename (_tmp13_);
		result = _tmp14_;
		_g_free0 (file_name);
		return result;
	}
	budgie_windowing_window_mapper_check_invalidated (self);
	_tmp15_ = budgie_windowing_window_mapper_query_atom_string (self, (gulong) xfw_window_x11_get_xid (window), gdk_atom_intern ("_GTK_APPLICATION_ID", FALSE), TRUE);
	gtk_id = _tmp15_;
	_tmp16_ = gtk_id;
	if (_tmp16_ != NULL) {
		gchar* desktop_id = NULL;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		GHashTable* _tmp22_;
		const gchar* _tmp23_;
		_tmp17_ = gtk_id;
		_tmp18_ = g_utf8_strdown (_tmp17_, (gssize) -1);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_strconcat (_tmp19_, ".desktop", NULL);
		_tmp21_ = _tmp20_;
		_g_free0 (_tmp19_);
		desktop_id = _tmp21_;
		_tmp22_ = self->priv->applications;
		_tmp23_ = desktop_id;
		if (g_hash_table_contains (_tmp22_, _tmp23_)) {
			GHashTable* _tmp24_;
			const gchar* _tmp25_;
			gconstpointer _tmp26_;
			GDesktopAppInfo* _tmp27_;
			_tmp24_ = self->priv->applications;
			_tmp25_ = desktop_id;
			_tmp26_ = g_hash_table_lookup (_tmp24_, _tmp25_);
			_tmp27_ = _g_object_ref0 ((GDesktopAppInfo*) _tmp26_);
			result = _tmp27_;
			_g_free0 (desktop_id);
			_g_free0 (gtk_id);
			return result;
		}
		_g_free0 (desktop_id);
	}
	_tmp28_ = wnck_window_get ((gulong) xfw_window_x11_get_xid (window));
	wnck_window = _tmp28_;
	_tmp29_ = wnck_window;
	_tmp30_ = wnck_window_get_class_group_name (_tmp29_);
	_tmp31_ = g_strdup (_tmp30_);
	class_group_name = _tmp31_;
	_tmp32_ = class_group_name;
	if (_tmp32_ == NULL) {
		gchar* _tmp33_;
		_tmp33_ = budgie_windowing_window_mapper_get_group_name (self, window);
		_g_free0 (class_group_name);
		class_group_name = _tmp33_;
	}
	_tmp34_ = class_group_name;
	if (_tmp34_ != NULL) {
		GDesktopAppInfo* info = NULL;
		const gchar* _tmp35_;
		GDesktopAppInfo* _tmp36_;
		GDesktopAppInfo* _tmp37_;
		_tmp35_ = class_group_name;
		_tmp36_ = budgie_windowing_window_mapper_query_name (self, _tmp35_);
		info = _tmp36_;
		_tmp37_ = info;
		if (_tmp37_ != NULL) {
			result = info;
			_g_free0 (class_group_name);
			_g_free0 (gtk_id);
			return result;
		}
		_g_object_unref0 (info);
	}
	_tmp38_ = wnck_window;
	_tmp39_ = wnck_window_get_class_instance_name (_tmp38_);
	instance_name = _tmp39_;
	_tmp40_ = instance_name;
	if (_tmp40_ != NULL) {
		GDesktopAppInfo* info = NULL;
		const gchar* _tmp41_;
		GDesktopAppInfo* _tmp42_;
		GDesktopAppInfo* _tmp43_;
		_tmp41_ = instance_name;
		_tmp42_ = budgie_windowing_window_mapper_query_name (self, _tmp41_);
		info = _tmp42_;
		_tmp43_ = info;
		if (_tmp43_ != NULL) {
			result = info;
			_g_free0 (class_group_name);
			_g_free0 (gtk_id);
			return result;
		}
		_g_object_unref0 (info);
	}
	result = NULL;
	_g_free0 (class_group_name);
	_g_free0 (gtk_id);
	return result;
}

BudgieWindowingWindowMapper*
budgie_windowing_window_mapper_construct (GType object_type)
{
	BudgieWindowingWindowMapper * self = NULL;
	self = (BudgieWindowingWindowMapper*) g_object_new (object_type, NULL);
	return self;
}

BudgieWindowingWindowMapper*
budgie_windowing_window_mapper_new (void)
{
	return budgie_windowing_window_mapper_construct (BUDGIE_WINDOWING_TYPE_WINDOW_MAPPER);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_budgie_windowing_window_mapper_on_dbus_get_gasync_ready_callback (GObject* source_object,
                                                                   GAsyncResult* res,
                                                                   gpointer self)
{
	budgie_windowing_window_mapper_on_dbus_get ((BudgieWindowingWindowMapper*) self, source_object, res);
	g_object_unref (self);
}

static gboolean
__lambda5_ (BudgieWindowingWindowMapper* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
		g_rec_mutex_lock (&self->priv->__lock_invalidated);
		{
			self->priv->invalidated = TRUE;
		}
		__finally0:
		{
			g_rec_mutex_unlock (&self->priv->__lock_invalidated);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp0_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp0_;
		}
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((BudgieWindowingWindowMapper*) self);
	return result;
}

static void
_budgie_windowing_window_mapper___lambda4_ (BudgieWindowingWindowMapper* self)
{
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda5__gsource_func, g_object_ref (self), g_object_unref);
}

static void
__budgie_windowing_window_mapper___lambda4__g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                        gpointer self)
{
	_budgie_windowing_window_mapper___lambda4_ ((BudgieWindowingWindowMapper*) self);
}

static GObject *
budgie_windowing_window_mapper_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BudgieWindowingWindowMapper * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	GHashFunc _tmp6_;
	GEqualFunc _tmp7_;
	GHashTable* _tmp8_;
	GHashFunc _tmp9_;
	GEqualFunc _tmp10_;
	GHashTable* _tmp11_;
	GHashTable* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GHashTable* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GHashTable* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GHashTable* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GHashTable* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GHashTable* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GHashTable* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GAppInfoMonitor* _tmp33_;
	GAppInfoMonitor* _tmp34_;
	parent_class = G_OBJECT_CLASS (budgie_windowing_window_mapper_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_WINDOWING_TYPE_WINDOW_MAPPER, BudgieWindowingWindowMapper);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (self->priv->applications);
	self->priv->applications = _tmp2_;
	_tmp3_ = g_str_hash;
	_tmp4_ = g_str_equal;
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (self->priv->startup_infos);
	self->priv->startup_infos = _tmp5_;
	_tmp6_ = g_str_hash;
	_tmp7_ = g_str_equal;
	_tmp8_ = g_hash_table_new_full (_tmp6_, _tmp7_, _g_free0_, _g_free0_);
	_g_hash_table_unref0 (self->priv->simpletons);
	self->priv->simpletons = _tmp8_;
	_tmp9_ = g_str_hash;
	_tmp10_ = g_str_equal;
	_tmp11_ = g_hash_table_new_full (_tmp9_, _tmp10_, _g_free0_, _g_free0_);
	_g_hash_table_unref0 (self->priv->pids);
	self->priv->pids = _tmp11_;
	_tmp12_ = self->priv->simpletons;
	_tmp13_ = g_strdup ("google-chrome-stable");
	_tmp14_ = g_strdup ("google-chrome");
	g_hash_table_insert (_tmp12_, _tmp13_, _tmp14_);
	_tmp15_ = self->priv->simpletons;
	_tmp16_ = g_strdup ("calibre-gui");
	_tmp17_ = g_strdup ("calibre");
	g_hash_table_insert (_tmp15_, _tmp16_, _tmp17_);
	_tmp18_ = self->priv->simpletons;
	_tmp19_ = g_strdup ("code - oss");
	_tmp20_ = g_strdup ("vscode-oss");
	g_hash_table_insert (_tmp18_, _tmp19_, _tmp20_);
	_tmp21_ = self->priv->simpletons;
	_tmp22_ = g_strdup ("code");
	_tmp23_ = g_strdup ("vscode");
	g_hash_table_insert (_tmp21_, _tmp22_, _tmp23_);
	_tmp24_ = self->priv->simpletons;
	_tmp25_ = g_strdup ("psppire");
	_tmp26_ = g_strdup ("pspp");
	g_hash_table_insert (_tmp24_, _tmp25_, _tmp26_);
	_tmp27_ = self->priv->simpletons;
	_tmp28_ = g_strdup ("gnome-twitch");
	_tmp29_ = g_strdup ("com.vinszent.gnometwitch");
	g_hash_table_insert (_tmp27_, _tmp28_, _tmp29_);
	_tmp30_ = self->priv->simpletons;
	_tmp31_ = g_strdup ("anoise.py");
	_tmp32_ = g_strdup ("anoise");
	g_hash_table_insert (_tmp30_, _tmp31_, _tmp32_);
	g_bus_get (G_BUS_TYPE_SESSION, NULL, _budgie_windowing_window_mapper_on_dbus_get_gasync_ready_callback, g_object_ref (self));
	_tmp33_ = g_app_info_monitor_get ();
	_g_object_unref0 (self->priv->monitor);
	self->priv->monitor = _tmp33_;
	_tmp34_ = self->priv->monitor;
	g_signal_connect_object (_tmp34_, "changed", (GCallback) __budgie_windowing_window_mapper___lambda4__g_app_info_monitor_changed, self, 0);
	budgie_windowing_window_mapper_load_app_infos (self);
	return obj;
}

static void
budgie_windowing_window_mapper_class_init (BudgieWindowingWindowMapperClass * klass,
                                           gpointer klass_data)
{
	budgie_windowing_window_mapper_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BudgieWindowingWindowMapper_private_offset);
	G_OBJECT_CLASS (klass)->constructor = budgie_windowing_window_mapper_constructor;
	G_OBJECT_CLASS (klass)->finalize = budgie_windowing_window_mapper_finalize;
}

static void
budgie_windowing_window_mapper_instance_init (BudgieWindowingWindowMapper * self,
                                              gpointer klass)
{
	self->priv = budgie_windowing_window_mapper_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_invalidated);
	self->priv->invalidated = FALSE;
}

static void
budgie_windowing_window_mapper_finalize (GObject * obj)
{
	BudgieWindowingWindowMapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_WINDOWING_TYPE_WINDOW_MAPPER, BudgieWindowingWindowMapper);
	_g_hash_table_unref0 (self->priv->applications);
	_g_hash_table_unref0 (self->priv->startup_infos);
	_g_hash_table_unref0 (self->priv->simpletons);
	_g_hash_table_unref0 (self->priv->pids);
	_g_object_unref0 (self->priv->monitor);
	_g_object_unref0 (self->priv->bus);
	g_rec_mutex_clear (&self->priv->__lock_invalidated);
	G_OBJECT_CLASS (budgie_windowing_window_mapper_parent_class)->finalize (obj);
}

static GType
budgie_windowing_window_mapper_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieWindowingWindowMapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_windowing_window_mapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieWindowingWindowMapper), 0, (GInstanceInitFunc) budgie_windowing_window_mapper_instance_init, NULL };
	GType budgie_windowing_window_mapper_type_id;
	budgie_windowing_window_mapper_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieWindowingWindowMapper", &g_define_type_info, 0);
	BudgieWindowingWindowMapper_private_offset = g_type_add_instance_private (budgie_windowing_window_mapper_type_id, sizeof (BudgieWindowingWindowMapperPrivate));
	return budgie_windowing_window_mapper_type_id;
}

GType
budgie_windowing_window_mapper_get_type (void)
{
	static volatile gsize budgie_windowing_window_mapper_type_id__once = 0;
	if (g_once_init_enter (&budgie_windowing_window_mapper_type_id__once)) {
		GType budgie_windowing_window_mapper_type_id;
		budgie_windowing_window_mapper_type_id = budgie_windowing_window_mapper_get_type_once ();
		g_once_init_leave (&budgie_windowing_window_mapper_type_id__once, budgie_windowing_window_mapper_type_id);
	}
	return budgie_windowing_window_mapper_type_id__once;
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

